=== crypto/base64/CMakeLists.txt ===
include_directories(../../include)

add_library(
  base64

  OBJECT

  base64.c
)
