=== crypto/lhash/CMakeLists.txt ===
include_directories(../../include)

add_library(
  lhash

  OBJECT

  lhash.c
)
