=== crypto/bn_extra/CMakeLists.txt ===
include_directories(../../include)

add_library(
  bn_extra

  OBJECT

  bn_asn1.c
  convert.c
)
