=== crypto/conf/CMakeLists.txt ===
include_directories(../../include)

add_library(
  conf

  OBJECT

  conf.c
)
