=== crypto/digest_extra/CMakeLists.txt ===
include_directories(../../include)

add_library(
  digest_extra

  OBJECT

  digest_extra.c
)
