=== crypto/ecdsa_extra/CMakeLists.txt ===
include_directories(../../include)

add_library(
  ecdsa_extra

  OBJECT

  ecdsa_asn1.c
)
