=== debian/changelog ===
android-platform-external-boringssl (8.1.0+r23-2~18.04) bionic; urgency=medium

  * Backport for OpenJDK 11. LP: #1819448.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Mar 2019 13:47:35 +0100

android-platform-external-boringssl (8.1.0+r23-2) unstable; urgency=medium

  * Update d/copyright:
    * Cover all copyright holders (Closes: #905820)
    * Point the Source to AOSP
  * Standards-Version => 4.2.1

 -- Kai-Chung Yan <seamlikok@gmail.com>  Fri, 21 Sep 2018 16:43:18 +0800

android-platform-external-boringssl (8.1.0+r23-1) unstable; urgency=medium

  * Initial release (Closes: #823933)

 -- Kai-Chung Yan <seamlikok@gmail.com>  Mon, 28 May 2018 19:53:05 +0200
