## android-platform-external-boringssl 8.1.1-1+r23-2.2

=== debian/changelog ===
android-platform-external-boringssl (1:8.1.1-1+r23-2.2-1+eagle) unstable; urgency=low

  * ['Autobuild release-candidate: f71b97d9ccb172d620b0decf243f1659518d9285']

 -- shuttle <shuttle@deepin.com>  Wed, 08 Jul 2020 17:03:31 +0000
