=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Homepage: https://android.googlesource.com/platform/external/boringssl
 
 Package: android-libboringssl
-Architecture: armel armhf arm64 amd64 i386 ppc64el
+Architecture: armel armhf arm64 amd64 i386 ppc64el mips64el
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Google's internal fork of OpenSSL for the Android SDK
  The Android SDK builds against a static version of BoringSSL,
@@ -33,7 +33,7 @@
 
 Package: android-libboringssl-dev
 Section: libdevel
-Architecture: armel armhf arm64 amd64 i386 ppc64el
+Architecture: armel armhf arm64 amd64 i386 ppc64el mips64el
 Depends: android-libboringssl (= ${binary:Version}), ${misc:Depends}
 Description: Google's internal fork of OpenSSL for the Android SDK - devel
  The Android SDK builds against a static version of BoringSSL,
